<template>
  <no-ssr>
    <div class="macd-chart">
      <Icon v-if="lockP5Drawing" class="p5-lock" type="md-lock" />
      <nuxt-p5 :id="domId"
               :width="width"
               :height="height"
               @size="sizeAction" v-on="script">
      </nuxt-p5>
    </div>
  </no-ssr>
</template>

<script>
  import NuxtP5 from './NuxtP5';
  import { script, actions, emits, events, functions, baseConfig } from '../../helpers/p5';

  const p5Events = {
    ...events,
    _draw(sketch) {
      if (!this.lockP5Drawing) {
        this.sketch = sketch;
        this.drawBackground(sketch);
        this.drawCoordinateSystem(sketch);
        this.drawDataPointBar(sketch);
        this.drawCrossHair(sketch);
      }
    },
  };

  const p5Functions = {
    ...functions,
    drawDataPointBar(sketch) {
      const firstIndex = this.dataKeys.indexOf(this.canvas.show.points[0].key);
      const zeroMACDY = this.dataToPoint(firstIndex, 0).y;

      this.canvas.show.points.forEach((point) => {
        // MACD value - zero
        let rectHeight = point.y['macdBar'] - zeroMACDY;
        sketch.fill((rectHeight < 0) ? 'rgba(255,102,102,0.71)' : 'rgba(54,188,245,0.71)');
        sketch.noStroke();
        sketch.rect(point.x - this.canvas.xUnit/2, zeroMACDY, this.canvas.xUnit, rectHeight);
      });
    },
  };

  export default {
    name: "StockMacdBarChart",
    mixins: [baseConfig],
    components: {NuxtP5},
    props: {},
    data() {
      return {
        domId: `macd-chart-${(new Date()).getTime().toString()}`,
        script: script(this),
        canvas: {
          coordinate: {
            step: 0.01,
            longMarkStep: 1,
            shortMarkStep: 0.5,
          },
        },
        dataFields: [
          { dataField: 'macdBar', label: 'MACD', color: '#ff6666' },
        ],
        fieldToShow: ['macdBar'],
      };
    },
    computed: {},
    watch: {},
    methods: {
      ...actions,
      ...emits,
      ...p5Events,
      ...p5Functions,
    },
    mounted() {},
  }
</script>

<style scoped>

</style>
